// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlDockTransientGrab")]
    pub struct DockTransientGrab(Object<ffi::DzlDockTransientGrab, ffi::DzlDockTransientGrabClass>);

    match fn {
        type_ => || ffi::dzl_dock_transient_grab_get_type(),
    }
}

impl DockTransientGrab {
    #[doc(alias = "dzl_dock_transient_grab_new")]
    pub fn new() -> DockTransientGrab {
        assert_initialized_main_thread!();
        unsafe { from_glib_full(ffi::dzl_dock_transient_grab_new()) }
    }

    #[doc(alias = "dzl_dock_transient_grab_acquire")]
    pub fn acquire(&self) {
        unsafe {
            ffi::dzl_dock_transient_grab_acquire(self.to_glib_none().0);
        }
    }

    //#[doc(alias = "dzl_dock_transient_grab_add_item")]
    //pub fn add_item(&self, item: /*Ignored*/&DockItem) {
    //    unsafe { TODO: call ffi:dzl_dock_transient_grab_add_item() }
    //}

    #[doc(alias = "dzl_dock_transient_grab_cancel")]
    pub fn cancel(&self) {
        unsafe {
            ffi::dzl_dock_transient_grab_cancel(self.to_glib_none().0);
        }
    }

    //#[doc(alias = "dzl_dock_transient_grab_contains")]
    //pub fn contains(&self, item: /*Ignored*/&DockItem) -> bool {
    //    unsafe { TODO: call ffi:dzl_dock_transient_grab_contains() }
    //}

    #[doc(alias = "dzl_dock_transient_grab_get_timeout")]
    #[doc(alias = "get_timeout")]
    pub fn timeout(&self) -> u32 {
        unsafe { ffi::dzl_dock_transient_grab_get_timeout(self.to_glib_none().0) }
    }

    #[doc(alias = "dzl_dock_transient_grab_is_descendant")]
    pub fn is_descendant(&self, widget: &impl IsA<gtk::Widget>) -> bool {
        unsafe {
            from_glib(ffi::dzl_dock_transient_grab_is_descendant(
                self.to_glib_none().0,
                widget.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_dock_transient_grab_release")]
    pub fn release(&self) {
        unsafe {
            ffi::dzl_dock_transient_grab_release(self.to_glib_none().0);
        }
    }

    //#[doc(alias = "dzl_dock_transient_grab_remove_item")]
    //pub fn remove_item(&self, item: /*Ignored*/&DockItem) {
    //    unsafe { TODO: call ffi:dzl_dock_transient_grab_remove_item() }
    //}

    #[doc(alias = "dzl_dock_transient_grab_set_timeout")]
    pub fn set_timeout(&self, timeout: u32) {
        unsafe {
            ffi::dzl_dock_transient_grab_set_timeout(self.to_glib_none().0, timeout);
        }
    }

    #[doc(alias = "dzl_dock_transient_grab_steal_common_ancestors")]
    pub fn steal_common_ancestors(&self, other: &DockTransientGrab) {
        unsafe {
            ffi::dzl_dock_transient_grab_steal_common_ancestors(
                self.to_glib_none().0,
                other.to_glib_none().0,
            );
        }
    }

    #[doc(alias = "timeout")]
    pub fn connect_timeout_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_timeout_trampoline<F: Fn(&DockTransientGrab) + 'static>(
            this: *mut ffi::DzlDockTransientGrab,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::timeout\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_timeout_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl Default for DockTransientGrab {
    fn default() -> Self {
        Self::new()
    }
}

impl fmt::Display for DockTransientGrab {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("DockTransientGrab")
    }
}
